/**
 * usage: lage <date>
 *
 * date: DDMMYY
 * e.g. 070306 -> Mar 07, 2006
 *
 * (c) 2006 Andreas Krennmair <ak@synflood.at>
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

void usage(char * argv0) {
  fprintf(stderr,"%s: usage: %s <date>\n\t\tdate is DDMMYY, e.g. 070306 stands for March 07, 2006\n",argv0,argv0);
  exit(1);
}

int main(int argc, char * argv[]) {
  if (argc<2) {
    usage(argv[0]?argv[0]:"lage");
  }
  char * date = argv[1];
  if (strlen(date) != 6) {
    fprintf(stderr,"error: invalid date format. Valid format: DDMMYY\n");
    exit(1);
  }
  char dd[3];
  char mm[3];
  char yy[3];
  dd[0] = '\0'; mm[0] = '\0'; yy[0] = '\0';
  strncat(dd,date,2);
  strncat(mm,date+2,2);
  strncat(yy,date+4,2);

  struct tm enddate;
  memset(&enddate,0,sizeof(enddate));

  enddate.tm_sec = 0;
  enddate.tm_min = 0;
  enddate.tm_hour = 0;
  enddate.tm_mday = strtoul(dd,NULL,10);
  enddate.tm_mon = strtoul(mm,NULL,10) - 1;
  enddate.tm_year = 100 + strtoul(yy,NULL,10); /* Y2K, my ass! */
  enddate.tm_isdst = -1;

  time_t ted = mktime(&enddate);
  time_t now = time(NULL);

  /* normalize "now": */
  struct tm tmp;
  memcpy(&tmp,localtime(&now),sizeof(tmp));
  tmp.tm_sec = tmp.tm_min = tmp.tm_hour = 0;
  now = mktime(&tmp);

  /* compute difference: */
  time_t lagesec = ted - now;

  unsigned int lagedays = lagesec / (24*60*60);

  printf("Lage: %03u\n",lagedays);

}
